
/** @file
    @brief		bcc`ĐNX
    @author		t`
    @since		2003.07.01
*/

//=============================================================================
// INCLUDE
//=============================================================================
#include "LunaBase.h"


#include "LunaCDDA.h"


namespace lunadxmath{
#if LUNA_DX_MATH_USE_CDDA
//=============================================================================
// VARIABLE
//=============================================================================
TRACKDATA *LunaCDDA::m_pTrackData;
Uint32 LunaCDDA::m_TrackMax;
Uint32 LunaCDDA::m_StartPos;
Uint32 LunaCDDA::m_EndPos;
Uint32 LunaCDDA::m_CurrenrPos;
Sint32 LunaCDDA::m_StartTrack;
Sint32 LunaCDDA::m_EndTrack;
Uint32 LunaCDDA::m_DeviceID;
char LunaCDDA::m_DeviceName[32];
bool LunaCDDA::m_IsOpen;
bool LunaCDDA::m_IsPlay;
bool LunaCDDA::m_IsPause;
bool LunaCDDA::m_IsLoop;


//=============================================================================
/**
	bcc`NX̏܂B

	@retval true		
	@retval false		s
*/
//=============================================================================
bool LunaCDDA::Initialize( void )
{
	//Luna::LogoutMainCategory( "LunaCDDANX̏" );
	//Luna::LogoutNextLine();

	return true;
}

//=============================================================================
/**
	bcc`NX̉܂B

*/
//=============================================================================
void LunaCDDA::Finalize( void )
{
	//Luna::LogoutMainCategory( "LunaCDDANX̉" );
	//Luna::LogoutNextLine();

	// 
	Close();
}

//=============================================================================
/**
	CDfoCXI[v܂

	@param pDeviceName		[in] foCX

	@retval true	
	@retval false	s
*/
//=============================================================================
bool LunaCDDA::Open( const char *pDeviceName )
{
	//----------------------------------------------------------
	// JĂȂ
	//----------------------------------------------------------
	Close();

	//----------------------------------------------------------
	// foCXۑ
	//----------------------------------------------------------
	strcpy( m_DeviceName, pDeviceName );

	//----------------------------------------------------------
	// CDfoCXI[v
	//----------------------------------------------------------
	MCI_OPEN_PARMS MciOpen;
	MemoryClear( &MciOpen, sizeof(MCI_OPEN_PARMS) );

	char ElementName[4];
	Uint32 Flags;

	// CDI[v
	MciOpen.lpstrDeviceType	= (LPTSTR)MCI_DEVTYPE_CD_AUDIO;
	Flags = MCI_OPEN_SHAREABLE | MCI_OPEN_TYPE | MCI_OPEN_TYPE_ID;

	// hCu̎w
	if ( pDeviceName != NULL )
	{
		Flags |= MCI_OPEN_ELEMENT;
		sprintf( ElementName, "%c:", pDeviceName );
		MciOpen.lpstrElementName = ElementName;
	}

	// foCXI[v
	if ( ::mciSendCommand( 0, MCI_OPEN, Flags, (Uint32)((void *)&MciOpen) ) != 0 )
	{
		return false;
	}

	m_DeviceID = MciOpen.wDeviceID;
	m_IsOpen = true;

	//----------------------------------------------------------
	// CD擾
	//----------------------------------------------------------
	MCI_STATUS_PARMS MciState;
	MemoryClear( &MciState, sizeof(MCI_STATUS_PARMS) );

	// gbN擾
	MciState.dwItem = MCI_STATUS_NUMBER_OF_TRACKS;
	if ( ::mciSendCommand( m_DeviceID, MCI_STATUS, MCI_STATUS_ITEM, (Uint32)((void *)&MciState) ) != 0 )
	{
		Close();
		return false;
	}

	m_TrackMax = (Uint32)MciState.dwReturn;
	m_pTrackData = (TRACKDATA*)MemoryAlloc( sizeof(TRACKDATA) * (m_TrackMax + 2) );

	// CD擾
	MciState.dwItem = MCI_STATUS_LENGTH;
	if ( ::mciSendCommand( m_DeviceID, MCI_STATUS, MCI_STATUS_ITEM, (Uint32)((void *)&MciState) ) != 0 )
	{
		Close();
		return false;
	}

	// 
	m_pTrackData[0].TrackLength = (Uint32)MciState.dwReturn;

	// Ō̃gbN+1ɂL^Ă
	m_pTrackData[m_TrackMax+1].TrackStart = (Uint32)MciState.dwReturn;
	m_pTrackData[m_TrackMax+1].TrackLength = 0;

	//----------------------------------------------------------
	// gbN擾
	//----------------------------------------------------------
	for ( Uint32 i = 1; i <= m_TrackMax; i++ )
	{
		// gbNʒu擾
		MciState.dwItem = MCI_STATUS_POSITION;
		MciState.dwTrack = i;
		if ( ::mciSendCommand( m_DeviceID, MCI_STATUS, MCI_STATUS_ITEM|MCI_TRACK, (Uint32)((void *)&MciState) ) != 0 )
		{
			Close();
			return false;
		}

		m_pTrackData[i].TrackStart = (Uint32)MciState.dwReturn;

		// gbN擾
		MciState.dwItem = MCI_STATUS_LENGTH;
		MciState.dwTrack = i;
		if ( ::mciSendCommand( m_DeviceID, MCI_STATUS, MCI_STATUS_ITEM|MCI_TRACK, (Uint32)((void *)&MciState) ) != 0 )
		{
			Close();
			return false;
		}

		m_pTrackData[i].TrackLength = (Uint32)MciState.dwReturn;
	}

	return true;
}

//=============================================================================
/**
	CDfoCXN[Y܂

*/
//=============================================================================
void LunaCDDA::Close( void )
{
	if ( m_IsOpen )
	{
		// Ƃ肠~
		Stop();

		// foCXN[Y
		::mciSendCommand( m_DeviceID, MCI_CLOSE, 0, 0 );
		MemoryFree( m_pTrackData );
	}
}

//=============================================================================
/**
	bc̒~܂

	@retval true	
	@retval false	s
*/
//=============================================================================
bool LunaCDDA::Stop( void )
{
	if ( !m_IsOpen ) return false;
	if ( !m_IsPlay ) return false;

	m_IsPlay = false;

	// ~
	if ( ::mciSendCommand( m_DeviceID, MCI_STOP, 0, 0 ) != 0 )
	{
		return false;
	}

	return true;
}

//=============================================================================
/**
	bc̈ꎞ~܂

	@retval true	
	@retval false	s
*/
//=============================================================================
bool LunaCDDA::Pause( void )
{
	if ( !m_IsOpen ) return false;
	if ( !m_IsPlay ) return false;

	if ( m_IsPause )
	{
		m_IsPause = false;

		// Đ
		MCI_PLAY_PARMS MciPlay;
		MemoryClear( &MciPlay, sizeof(MCI_PLAY_PARMS) );

		MciPlay.dwFrom		= m_CurrenrPos;
		MciPlay.dwTo		= m_EndPos;
		MciPlay.dwCallback	= (Uint32)Luna::GetWindowHandle();

		// ĐJn
		if ( ::mciSendCommand( m_DeviceID, MCI_PLAY, MCI_FROM|MCI_TO|MCI_NOTIFY, (Uint32)((void *)&MciPlay) ) != 0 )
		{
			Close();
			return false;
		}
	}
	else
	{
		m_IsPause = true;

		// ݂̍Đ|WV𓾂
		MCI_STATUS_PARMS MciStatus;
		MemoryClear( &MciStatus, sizeof(MCI_STATUS_PARMS) );
		MciStatus.dwItem = MCI_STATUS_POSITION;
		if ( ::mciSendCommand( m_DeviceID, MCI_STATUS, MCI_STATUS_ITEM, (Uint32)((void *)&MciStatus) ) != 0 )
		{
			return false;
		}

		// ݈ʒu
		m_CurrenrPos = (Uint32)MciStatus.dwReturn;

		// ~
		if ( ::mciSendCommand( m_DeviceID, MCI_STOP, 0, 0 ) != 0 )
		{
			return false;
		}
	}

	return true;
}

//=============================================================================
/**
	bc̃[v܂

	@param wParam	[in] EBhEbZ[W̃p[^
	@param lParam	[in] EBhEbZ[W̃p[^

	@retval true	
	@retval false	s
*/
//=============================================================================
bool LunaCDDA::Replay( WPARAM wParam, LPARAM lParam )
{
	// foCXԍĂH
	if ( lParam != (LPARAM)m_DeviceID )
	{
		return false;
	}

	// Đۂ̂ŃgC
	if ( wParam == MCI_NOTIFY_SUCCESSFUL )
	{
		if ( m_IsLoop )
		{
			Play( m_StartTrack, m_EndTrack, m_IsLoop );
		}
	}

	return true;
}

//=============================================================================
/**
	bc̍Đ܂

	@param IsLoop	[in] [v邩ۂ

	@retval true	
	@retval false	s
*/
//=============================================================================
bool LunaCDDA::Play( bool IsLoop )
{
	return Play( 1, m_TrackMax - 1, IsLoop );
}

//=============================================================================
/**
	bc̍Đ܂

	@param Track	[in] gbN
	@param IsLoop	[in] [v邩ۂ

	@retval true	
	@retval false	s
*/
//=============================================================================
bool LunaCDDA::Play( Sint32 Track, bool IsLoop )
{
	return Play( Track, Track, IsLoop );
}

//=============================================================================
/**
	bc̍Đ܂

	@retval true	
	@retval false	s
*/
//=============================================================================
bool LunaCDDA::Play( Sint32 Track1, Sint32 Track2, bool IsLoop )
{
	if ( !m_IsOpen ) return false;
	if ( m_IsPlay ) return false;

	// Đ
	MCI_PLAY_PARMS MciPlay;
	MemoryClear( &MciPlay, sizeof(MCI_PLAY_PARMS) );

	MciPlay.dwFrom		= m_pTrackData[Track1].TrackStart;
	MciPlay.dwTo		= m_pTrackData[Track2 + 1].TrackStart;
	MciPlay.dwCallback	= (Uint32)Luna::GetWindowHandle();

	m_StartPos		= MciPlay.dwFrom;
	m_EndPos		= MciPlay.dwTo;
	m_StartTrack	= Track1;
	m_EndTrack		= Track2;

	// ĐJn
	if ( ::mciSendCommand( m_DeviceID, MCI_PLAY, MCI_FROM|MCI_TO|MCI_NOTIFY, (Uint32)((void *)&MciPlay) ) != 0 )
	{
		Close();
		return false;
	}

	m_IsPlay = true;
	m_IsLoop = IsLoop;

	return true;
}

//=============================================================================
/**
	bc̑}^o܂

	@param IsEject	gCI[v true / N[Y false

	@retval true	
	@retval false	s
*/
//=============================================================================
bool LunaCDDA::Eject( bool IsEject )
{
	Uint32 Command;

	Close();

	if ( IsEject )
	{
		Command = MCI_SET_DOOR_OPEN;
	}
	else
	{
		Command = MCI_SET_DOOR_CLOSED;
	}

	if ( ::mciSendCommand( m_DeviceID, MCI_SET, Command, 0 ) )
	{
		return false;
	}

	return true;
}

#endif

}//eon
