
/** @file
    @brief		pNX
    @author		t`
    @since		2003.07.01
*/


//=============================================================================
// INCLUDE
//=============================================================================
#include "LunaBase.h"

#include "LunaStyle.h"
#include "LunaMath.h"

namespace lunadxmath{
//=============================================================================
/**
	RXgN^

*/
//=============================================================================
CStyle::CStyle()
{
	TransformInit();
}

//=============================================================================
/**
	RXgN^

*/
//=============================================================================
CStyle::CStyle( const CStyle &Style )
{
	Set( (CStyle*)&Style );
}

//=============================================================================
/**
	pf[^Rs[

	@param pStyle	[in] pf[^
*/
//=============================================================================
void CStyle::Set( CStyle *pStyle )
{
	TransformInit();

	m_mStyle.Set( pStyle->m_mStyle.Get() );
	m_mStyleInverse.Set( pStyle->m_mStyleInverse.Get() );
	m_mTransform.Set( pStyle->m_mTransform.Get() );
	m_mTransformInverse.Set( pStyle->m_mTransformInverse.Get() );

	m_vUp		= pStyle->m_vUp;
	m_vRight	= pStyle->m_vRight;
	m_vFront	= pStyle->m_vFront;
	m_vPosition	= pStyle->m_vPosition;
	m_vScale	= pStyle->m_vScale;
}

//=============================================================================
/**
	pf[^擾

	@param pStyle	[in] pf[^
*/
//=============================================================================
void CStyle::Get( CStyle *pStyle )
{
	pStyle->TransformInit();

	pStyle->m_mStyle.Set( m_mStyle.Get() );
	pStyle->m_mStyleInverse.Set( m_mStyleInverse.Get() );
	pStyle->m_mTransform.Set( m_mTransform.Get() );
	pStyle->m_mTransformInverse.Set( m_mTransformInverse.Get() );

	pStyle->m_vUp		= m_vUp;
	pStyle->m_vRight	= m_vRight;
	pStyle->m_vFront	= m_vFront;
	pStyle->m_vPosition	= m_vPosition;
	pStyle->m_vScale	= m_vScale;
}

//=============================================================================
/**
	p̏܂

*/
//=============================================================================
void CStyle::TransformInit( void )
{
	// p
	m_mStyle.Init();
	m_mStyle.Identity();
	// tp
	m_mStyleInverse.Init();
	m_mStyleInverse.Identity();
	// gXtH[
	m_mTransform.Init();
	m_mTransform.Identity();
	// tgXtH[
	m_mTransformInverse.Init();
	m_mTransformInverse.Identity();
	// 
	m_vUp.Set( 0.0f, 1.0f, 0.0f );
	// E
	m_vRight.Set( 1.0f, 0.0f, 0.0f );
	// O
	m_vFront.Set( 0.0f, 0.0f, 1.0f );
	// ʒu
	m_vPosition.Set( 0.0f, 0.0f, 0.0f );
	// gk
	m_vScale.Set( 1.0f, 1.0f, 1.0f );
}

//=============================================================================
/**
	p̕ϊXVAs쐬܂

*/
//=============================================================================
void CStyle::TransformUpdate( void )
{
	CMatrix mTemp;
	D3DXMATRIX *pMat;

	//------------------------------------------------------------
	// ps
	//------------------------------------------------------------
	pMat = m_mStyle.Get();

	pMat->m[0][0] = m_vRight.x; pMat->m[0][1] = m_vRight.y; pMat->m[0][2] = m_vRight.z; pMat->m[0][3] = 0.0f;
	pMat->m[1][0] = m_vUp.x;    pMat->m[1][1] = m_vUp.y;    pMat->m[1][2] = m_vUp.z;    pMat->m[1][3] = 0.0f;
	pMat->m[2][0] = m_vFront.x; pMat->m[2][1] = m_vFront.y; pMat->m[2][2] = m_vFront.z; pMat->m[2][3] = 0.0f;
	pMat->m[3][0] = 0.0f;       pMat->m[3][1] = 0.0f;       pMat->m[3][2] = 0.0f;       pMat->m[3][3] = 1.0f;

	//------------------------------------------------------------
	// gXtH[s񐶐
	//------------------------------------------------------------
	pMat = m_mTransform.Get();

	pMat->m[0][0] = m_vRight.x;    pMat->m[0][1] = m_vRight.y;    pMat->m[0][2] = m_vRight.z;    pMat->m[0][3] = 0.0f;
	pMat->m[1][0] = m_vUp.x;       pMat->m[1][1] = m_vUp.y;       pMat->m[1][2] = m_vUp.z;       pMat->m[1][3] = 0.0f;
	pMat->m[2][0] = m_vFront.x;    pMat->m[2][1] = m_vFront.y;    pMat->m[2][2] = m_vFront.z;    pMat->m[2][3] = 0.0f;
	pMat->m[3][0] = m_vPosition.x; pMat->m[3][1] = m_vPosition.y; pMat->m[3][2] = m_vPosition.z; pMat->m[3][3] = 1.0f;

	mTemp.Scaling( m_vScale.x, m_vScale.y, m_vScale.z );
	m_mTransform.Multiply( &mTemp, &m_mTransform );

	//------------------------------------------------------------
	// tps
	//------------------------------------------------------------
	pMat = m_mStyleInverse.Get();

	pMat->m[0][0] = m_vRight.x; pMat->m[0][1] = m_vUp.x; pMat->m[0][2] = m_vFront.x; pMat->m[0][3] = 0.0f;
	pMat->m[1][0] = m_vRight.y; pMat->m[1][1] = m_vUp.y; pMat->m[1][2] = m_vFront.y; pMat->m[1][3] = 0.0f;
	pMat->m[2][0] = m_vRight.z; pMat->m[2][1] = m_vUp.z; pMat->m[2][2] = m_vFront.z; pMat->m[2][3] = 0.0f;
	pMat->m[3][0] = 0.0f;       pMat->m[3][1] = 0.0f;    pMat->m[3][2] = 0.0f;       pMat->m[3][3] = 1.0f;

	//------------------------------------------------------------
	// tgXtH[s񐶐
	//------------------------------------------------------------
	pMat = m_mTransformInverse.Get();

	pMat->m[0][0] = m_vRight.x; pMat->m[0][1] = m_vUp.x; pMat->m[0][2] = m_vFront.x; pMat->m[0][3] = 0.0f;
	pMat->m[1][0] = m_vRight.y; pMat->m[1][1] = m_vUp.y; pMat->m[1][2] = m_vFront.y; pMat->m[1][3] = 0.0f;
	pMat->m[2][0] = m_vRight.z; pMat->m[2][1] = m_vUp.z; pMat->m[2][2] = m_vFront.z; pMat->m[2][3] = 0.0f;

	pMat->m[3][0] = -m_vPosition.DotProduct( &m_vRight );
	pMat->m[3][1] = -m_vPosition.DotProduct( &m_vUp );
	pMat->m[3][2] = -m_vPosition.DotProduct( &m_vFront );
	pMat->m[3][3] = 1.0f;
}

//=============================================================================
/**
	]s񂩂pf[^𐶐܂

	@param pMat		[in] ]s
*/
//=============================================================================
void CStyle::FromMatrix( CMatrix *pMat )
{
	D3DXMATRIX *pM = pMat->Get();

	m_vRight.x = pM->m[0][0];
	m_vRight.y = pM->m[0][1];
	m_vRight.z = pM->m[0][2];

	m_vUp.x = pM->m[1][0];
	m_vUp.y = pM->m[1][1];
	m_vUp.z = pM->m[1][2];

	m_vFront.x = pM->m[2][0];
	m_vFront.y = pM->m[2][1];
	m_vFront.z = pM->m[2][2];
}

//=============================================================================
/**
	pf[^̂w]px擾܂

	@return		]px
*/
//=============================================================================
Sint32 CStyle::GetAngleX( void )
{
	return GET_ANGLE_PI( F(asin(m_vFront.y)) );
}

//=============================================================================
/**
	pf[^̂x]px擾܂

	@return		]px
*/
//=============================================================================
Sint32 CStyle::GetAngleY( void )
{
	if ( (m_vFront.y == -1.0f) || (m_vFront.y == +1.0f) )
	{
		return GET_ANGLE_PI( F(atan2(m_vUp.x, m_vUp.z)) );
	}
	else
	{
		return GET_ANGLE_PI( F(atan2(m_vFront.x, m_vFront.z)) );
	}
}

//=============================================================================
/**
	pf[^̂y]px擾܂

	@return		]px
*/
//=============================================================================
Sint32 CStyle::GetAngleZ( void )
{
	Float fTemp = F(asin(m_vRight.y / F(sqrt(1.0f - m_vFront.y * m_vFront.y))));

	if ( m_vUp.y < 0 )
	{
		return GET_ANGLE_PI( PI - fTemp );
	}
	else
	{
		return GET_ANGLE_PI( fTemp );
	}
}

//=============================================================================
/**
	p̏Ԃwɉ]܂

	@param Rot		[in] ]pxiPUTTRUxj
*/
//=============================================================================
void CStyle::RotationX( Uint32 Rot )
{
	static CMatrix Mt[2];
	static D3DXMATRIX *pMt[2] = { Mt[0].Get(), Mt[1].Get() };

	Float fCos = LunaMath::Cos( Rot );
	Float fSin = LunaMath::Sin( Rot );

	pMt[0]->m[0][0] = m_vRight.x;  pMt[0]->m[0][1] = m_vRight.y;  pMt[0]->m[0][2] = m_vRight.z;  pMt[0]->m[0][3] = 0;
	pMt[0]->m[1][0] = m_vUp.x;     pMt[0]->m[1][1] = m_vUp.y;     pMt[0]->m[1][2] = m_vUp.z;     pMt[0]->m[1][3] = 0;
	pMt[0]->m[2][0] = m_vFront.x;  pMt[0]->m[2][1] = m_vFront.y;  pMt[0]->m[2][2] = m_vFront.z;  pMt[0]->m[2][3] = 0;
	pMt[0]->m[3][0] = 0;           pMt[0]->m[3][1] = 0;           pMt[0]->m[3][2] = 0;           pMt[0]->m[3][3] = 1;

	pMt[1]->m[0][0] = 1;  pMt[1]->m[0][1] =     0;  pMt[1]->m[0][2] =    0;  pMt[1]->m[0][3] = 0;
	pMt[1]->m[1][0] = 0;  pMt[1]->m[1][1] =  fCos;  pMt[1]->m[1][2] = fSin;  pMt[1]->m[1][3] = 0;
	pMt[1]->m[2][0] = 0;  pMt[1]->m[2][1] = -fSin;  pMt[1]->m[2][2] = fCos;  pMt[1]->m[2][3] = 0;
	pMt[1]->m[3][0] = 0;  pMt[1]->m[3][1] =     0;  pMt[1]->m[3][2] =    0;  pMt[1]->m[3][3] = 1;

	Mt[0].Multiply( &Mt[1] );

	m_vRight.x = pMt[0]->m[0][0];
	m_vRight.y = pMt[0]->m[0][1];
	m_vRight.z = pMt[0]->m[0][2];
	m_vUp.x    = pMt[0]->m[1][0];
	m_vUp.y    = pMt[0]->m[1][1];
	m_vUp.z    = pMt[0]->m[1][2];
	m_vFront.x = pMt[0]->m[2][0];
	m_vFront.y = pMt[0]->m[2][1];
	m_vFront.z = pMt[0]->m[2][2];
}

//=============================================================================
/**
	p̏Ԃxɉ]܂

	@param Rot		[in] ]pxiPUTTRUxj
*/
//=============================================================================
void CStyle::RotationY( Uint32 Rot )
{
	static CMatrix Mt[2];
	static D3DXMATRIX *pMt[2] = { Mt[0].Get(), Mt[1].Get() };

	Float fCos = LunaMath::Cos( Rot );
	Float fSin = LunaMath::Sin( Rot );

	pMt[0]->m[0][0] = m_vRight.x;  pMt[0]->m[0][1] = m_vRight.y;  pMt[0]->m[0][2] = m_vRight.z;  pMt[0]->m[0][3] = 0;
	pMt[0]->m[1][0] = m_vUp.x;     pMt[0]->m[1][1] = m_vUp.y;     pMt[0]->m[1][2] = m_vUp.z;     pMt[0]->m[1][3] = 0;
	pMt[0]->m[2][0] = m_vFront.x;  pMt[0]->m[2][1] = m_vFront.y;  pMt[0]->m[2][2] = m_vFront.z;  pMt[0]->m[2][3] = 0;
	pMt[0]->m[3][0] = 0;           pMt[0]->m[3][1] = 0;           pMt[0]->m[3][2] = 0;           pMt[0]->m[3][3] = 1;

	pMt[1]->m[0][0] = fCos;  pMt[1]->m[0][1] = 0;  pMt[1]->m[0][2] = -fSin;  pMt[1]->m[0][3] = 0;
	pMt[1]->m[1][0] =    0;  pMt[1]->m[1][1] = 1;  pMt[1]->m[1][2] =     0;  pMt[1]->m[1][3] = 0;
	pMt[1]->m[2][0] = fSin;  pMt[1]->m[2][1] = 0;  pMt[1]->m[2][2] =  fCos;  pMt[1]->m[2][3] = 0;
	pMt[1]->m[3][0] =    0;  pMt[1]->m[3][1] = 0;  pMt[1]->m[3][2] =     0;  pMt[1]->m[3][3] = 1;

	Mt[0].Multiply( &Mt[1] );

	m_vRight.x = pMt[0]->m[0][0];
	m_vRight.y = pMt[0]->m[0][1];
	m_vRight.z = pMt[0]->m[0][2];
	m_vUp.x    = pMt[0]->m[1][0];
	m_vUp.y    = pMt[0]->m[1][1];
	m_vUp.z    = pMt[0]->m[1][2];
	m_vFront.x = pMt[0]->m[2][0];
	m_vFront.y = pMt[0]->m[2][1];
	m_vFront.z = pMt[0]->m[2][2];
}

//=============================================================================
/**
	p̏Ԃyɉ]܂

	@param Rot		[in] ]pxiPUTTRUxj
*/
//=============================================================================
void CStyle::RotationZ( Uint32 Rot )
{
	static CMatrix Mt[2];
	static D3DXMATRIX *pMt[2] = { Mt[0].Get(), Mt[1].Get() };

	Float fCos = LunaMath::Cos( Rot );
	Float fSin = LunaMath::Sin( Rot );

	pMt[0]->m[0][0] = m_vRight.x;  pMt[0]->m[0][1] = m_vRight.y;  pMt[0]->m[0][2] = m_vRight.z;  pMt[0]->m[0][3] = 0;
	pMt[0]->m[1][0] = m_vUp.x;     pMt[0]->m[1][1] = m_vUp.y;     pMt[0]->m[1][2] = m_vUp.z;     pMt[0]->m[1][3] = 0;
	pMt[0]->m[2][0] = m_vFront.x;  pMt[0]->m[2][1] = m_vFront.y;  pMt[0]->m[2][2] = m_vFront.z;  pMt[0]->m[2][3] = 0;
	pMt[0]->m[3][0] = 0;           pMt[0]->m[3][1] = 0;           pMt[0]->m[3][2] = 0;           pMt[0]->m[3][3] = 1;

	pMt[1]->m[0][0] =  fCos;  pMt[1]->m[0][1] = fSin;  pMt[1]->m[0][2] = 0;  pMt[1]->m[0][3] = 0;
	pMt[1]->m[1][0] = -fSin;  pMt[1]->m[1][1] = fCos;  pMt[1]->m[1][2] = 0;  pMt[1]->m[1][3] = 0;
	pMt[1]->m[2][0] =     0;  pMt[1]->m[2][1] =    0;  pMt[1]->m[2][2] = 1;  pMt[1]->m[2][3] = 0;
	pMt[1]->m[3][0] =     0;  pMt[1]->m[3][1] =    0;  pMt[1]->m[3][2] = 0;  pMt[1]->m[3][3] = 1;

	Mt[0].Multiply( &Mt[1] );

	m_vRight.x = pMt[0]->m[0][0];
	m_vRight.y = pMt[0]->m[0][1];
	m_vRight.z = pMt[0]->m[0][2];
	m_vUp.x    = pMt[0]->m[1][0];
	m_vUp.y    = pMt[0]->m[1][1];
	m_vUp.z    = pMt[0]->m[1][2];
	m_vFront.x = pMt[0]->m[2][0];
	m_vFront.y = pMt[0]->m[2][1];
	m_vFront.z = pMt[0]->m[2][2];
}

//=============================================================================
/**
	psb`O܂

	@param Rot		[in] ]pxiPUTTRUxj
*/
//=============================================================================
void CStyle::Pitching( Uint32 Rot )
{
	static LVECTOR3 vTemp[3];
	vTemp[0] = m_vRight;
	vTemp[1] = m_vUp;
	vTemp[2] = m_vFront;

	Float fCos = LunaMath::Cos( Rot );
	Float fSin = LunaMath::Sin( Rot );

	m_vUp.x		= (+fCos * vTemp[1].x) + (+fSin * vTemp[2].x);
	m_vUp.y		= (+fCos * vTemp[1].y) + (+fSin * vTemp[2].y);
	m_vUp.z		= (+fCos * vTemp[1].z) + (+fSin * vTemp[2].z);

	m_vFront.x	= (-fSin * vTemp[1].x) + (+fCos * vTemp[2].x);
	m_vFront.y	= (-fSin * vTemp[1].y) + (+fCos * vTemp[2].y);
	m_vFront.z	= (-fSin * vTemp[1].z) + (+fCos * vTemp[2].z);
}

//=============================================================================
/**
	pwbfBO܂

	@param Rot		[in] ]pxiPUTTRUxj
*/
//=============================================================================
void CStyle::Heading( Uint32 Rot )
{
	static LVECTOR3 vTemp[3];
	vTemp[0] = m_vRight;
	vTemp[1] = m_vUp;
	vTemp[2] = m_vFront;

	Float fCos = LunaMath::Cos( Rot );
	Float fSin = LunaMath::Sin( Rot );

	m_vRight.x	= (+fCos * vTemp[0].x) + (-fSin * vTemp[2].x);
	m_vRight.y	= (+fCos * vTemp[0].y) + (-fSin * vTemp[2].y);
	m_vRight.z	= (+fCos * vTemp[0].z) + (-fSin * vTemp[2].z);

	m_vFront.x	= (+fSin * vTemp[0].x) + (+fCos * vTemp[2].x);
	m_vFront.y	= (+fSin * vTemp[0].y) + (+fCos * vTemp[2].y);
	m_vFront.z	= (+fSin * vTemp[0].z) + (+fCos * vTemp[2].z);
}

//=============================================================================
/**
	p[O܂

	@param Rot		[in] ]pxiPUTTRUxj
*/
//=============================================================================
void CStyle::Rolling( Uint32 Rot )
{
	static LVECTOR3 vTemp[3];
	vTemp[0] = m_vRight;
	vTemp[1] = m_vUp;
	vTemp[2] = m_vFront;

	Float fCos = LunaMath::Cos( Rot );
	Float fSin = LunaMath::Sin( Rot );

	m_vRight.x	= (+fCos * vTemp[0].x) + (+fSin * vTemp[1].x);
	m_vRight.y	= (+fCos * vTemp[0].y) + (+fSin * vTemp[1].y);
	m_vRight.z	= (+fCos * vTemp[0].z) + (+fSin * vTemp[1].z);

	m_vUp.x		= (-fSin * vTemp[0].x) + (+fCos * vTemp[1].x);
	m_vUp.y		= (-fSin * vTemp[0].y) + (+fCos * vTemp[1].y);
	m_vUp.z		= (-fSin * vTemp[0].z) + (+fCos * vTemp[1].z);
}

//=============================================================================
/**
	NH[^jIŉ]܂

	@param pQuat	[in] NH[^jI
*/
//=============================================================================
void CStyle::RotationQuaternion( CQuaternion *pQuat )
{
	CMatrix Matrix;
	Matrix = *pQuat;
	D3DXMATRIX *pM = Matrix.Get();

	m_vRight.x	= pM->m[0][0];
	m_vRight.y	= pM->m[0][1];
	m_vRight.z	= pM->m[0][2];

	m_vUp.x		= pM->m[1][0];
	m_vUp.y		= pM->m[1][1];
	m_vUp.z		= pM->m[1][2];

	m_vFront.x	= pM->m[2][0];
	m_vFront.y	= pM->m[2][1];
	m_vFront.z	= pM->m[2][2];
}

//=============================================================================
/**
	ʒuݒ肵܂

	@param fPx		[in] wʒu
	@param fPy		[in] xʒu
	@param fPz		[in] yʒu
*/
//=============================================================================
void CStyle::Translation( Float fPx, Float fPy, Float fPz )
{
	m_vPosition.Set( fPx, fPy, fPz );
}

//=============================================================================
/**
	TCYݒ肵܂

	@param fSx		[in] wTCY
	@param fSy		[in] xTCY
	@param fSz		[in] yTCY
*/
//=============================================================================
void CStyle::Scaling( Float fSx, Float fSy, Float fSz )
{
	m_vScale.Set( fSx, fSy, fSz );
}

//=============================================================================
/**
	Cӂ̈ʒuCӂ̈ʒu𒍎p쐬܂

	@param pEye		[in] ʒuxNg
	@param pAt		[in] _xNg
	@param pUp		[in] xNg
*/
//=============================================================================
void CStyle::LookAt( LVECTOR3 *pEye, LVECTOR3 *pAt, LVECTOR3 *pUp )
{
	static LVECTOR3 vFront, vRight, vUp;

	//--------------------------------------------------------
	// AbvxNg
	//--------------------------------------------------------
	if ( pUp != NULL )	vUp = *pUp;
	else				vUp.Set( 0, 1, 0 );

	//--------------------------------------------------------
	// J
	//--------------------------------------------------------
	vFront.Sub( pAt, pEye );
	vFront.Normalize();

	//--------------------------------------------------------
	// OSɐ^ォ^̎
	//--------------------------------------------------------
	if ( (vFront.y == 1.0) || (vFront.y == -1.0) )
	{
		// toxNgςĂ
		vUp.Set( 0, 0, -vFront.y );
	}

	//--------------------------------------------------------
	// JE
	//--------------------------------------------------------
	vRight.CrossProduct( &vFront, &vUp );
	vRight.Normalize();
	vRight.x = -vRight.x;
	vRight.y = -vRight.y;
	vRight.z = -vRight.z;

	//--------------------------------------------------------
	// 
	//--------------------------------------------------------
	vUp.CrossProduct( &vFront, &vRight );
	vUp.Normalize();

	//--------------------------------------------------------
	// Rs[
	//--------------------------------------------------------
	m_vFront	= vFront;
	m_vUp		= vUp;
	m_vRight	= vRight;
	m_vPosition	= *pEye;
}

}