
//==========================================================================
/** @file
    @brief		xNgZNX
    @author		t`
    @since		2003.07.01
*/
//==========================================================================


//==========================================================================
// INCLUDE
//==========================================================================
#include "LunaBase.h"

#include "LunaVector2.h"

namespace lunadxmath{
//==========================================================================
/**
	xNg̒̓擾܂B

    @return		̓
*/
//==========================================================================
Float CVector2::LengthSq( void )
{
	return ((x * x) + (y * y));
}

//==========================================================================
/**
	xNg̒擾܂

    @return		
*/
//==========================================================================
Float CVector2::Length( void )
{
	return (Float)sqrt( LengthSq() );
}

//==========================================================================
/**
	xNgƃxNg̓ς擾܂

	@param pIn		[in] ώZopxNg

    @return		ϒl
*/
//==========================================================================
Float CVector2::DotProduct( CVector2 *pIn )
{
	return ((x * pIn->x) + (y * pIn->y));
}

//==========================================================================
/**
	KxNg擾܂

	@param pIn		[in] KΏۂ̃xNg
*/
//==========================================================================
void CVector2::Normalize( CVector2 *pIn )
{
	Float div = 1.0f / pIn->Length();
	x = pIn->x * div;
	y = pIn->y * div;
}

//==========================================================================
/**
	xNgƃxNg̊Oς擾܂

	@param pIn1	[in] OώZopxNg
	@param pIn2	[in] OώZopxNg
*/
//==========================================================================
Float CVector2::CrossProduct( CVector2 *pIn1, CVector2 *pIn2 )
{
	return ((pIn1->x * pIn2->y) - (pIn1->y * pIn2->x));
}

//==========================================================================
/**
	Cӂ̃xNgɔ˂Cӂ̔˃xNg擾܂

	@param pIn1	[in] ˑΏۃxNg
	@param pIn2	[in] ˎxNg
*/
//==========================================================================
void CVector2::Reflect( CVector2 *pIn1, CVector2 *pIn2 )
{
	Float dot = pIn1->DotProduct( pIn2 );

	x = pIn1->x - (2 * dot * pIn2->x);
	y = pIn1->y - (2 * dot * pIn2->y);
}

//==========================================================================
/**
	xNg𐳋K܂

*/
//==========================================================================
void CVector2::Normalize( void )
{
	Float div = 1.0f / Length();
	x *= div;
	y *= div;
}

//==========================================================================
/**
	xNg̊Oςߌʂ擾

	@param pIn		[in] OϗpxNg
*/
//==========================================================================
Float CVector2::CrossProduct( CVector2 *pIn )
{
	CVector2 vTemp = *this;

	return ((vTemp.x * pIn->y) - (vTemp.y * pIn->x));
}

//==========================================================================
/**
	xNg𐳋K

	@param pIn		[in] ˎxNg
*/
//==========================================================================
void CVector2::Reflect( CVector2 *pIn )
{
	CVector2 vTemp = *this;
	Float dot = pIn->DotProduct( &vTemp );

	x = pIn->x - (2 * dot * vTemp.x);
	y = pIn->y - (2 * dot * vTemp.y);
}

//==========================================================================
/**
	xNggk܂

	@param sx		[in] wgk
	@param sy		[in] xgk
*/
//==========================================================================
void CVector2::Scaling( Float sx, Float sy )
{
	x *= sx;
	y *= sy;
}

//==========================================================================
/**
	xNgړ܂

	@param px		[in] wړ
	@param py		[in] xړ
*/
//==========================================================================
void CVector2::Translation( Float px, Float py )
{
	x += px;
	y += py;
}

//==========================================================================
/**
	xNgZʂ擾

	@param pIn1	[in] ZxNg
	@param pIn2	[in] ZpxNg
*/
//==========================================================================
void CVector2::Add( CVector2 *pIn1, CVector2 *pIn2 )
{
	x = pIn1->x + pIn2->x;
	y = pIn1->y + pIn2->y;
}

//==========================================================================
/**
	xNgZʂ擾

	@param pIn1	[in] ZxNg
	@param pIn2	[in] ZpxNg
*/
//==========================================================================
void CVector2::Sub( CVector2 *pIn1, CVector2 *pIn2 )
{
	x = pIn1->x - pIn2->x;
	y = pIn1->y - pIn2->y;
}


//==========================================================================
/**
	xNg̊evf̒lݒ

	@param fPx		[in] wl
	@param fPy		[in] xl
*/
//==========================================================================
void CVector2::Set( Float fPx, Float fPy )
{
	x = fPx;
	y = fPy;
}


CVector2 &CVector2::operator += ( const CVector2& v )
{
    x += v.x;
    y += v.y;
    return *this;
}

CVector2 &CVector2::operator -= ( const CVector2& v )
{
    x -= v.x;
    y -= v.y;
    return *this;
}

CVector2 &CVector2::operator *= ( Float f )
{
    x *= f;
    y *= f;
    return *this;
}

CVector2 &CVector2::operator /= ( Float f )
{
    Float fInv = 1.0f / f;
    x *= fInv;
    y *= fInv;
    return *this;
}

// unary operators
CVector2 CVector2::operator + () const
{
    return *this;
}

CVector2 CVector2::operator - () const
{
    return CVector2(-x, -y);
}

// binary operators
CVector2 CVector2::operator + ( const CVector2& v ) const
{
    return CVector2(x + v.x, y + v.y);
}

CVector2 CVector2::operator - ( const CVector2& v ) const
{
    return CVector2(x - v.x, y - v.y);
}

CVector2 CVector2::operator * ( Float f ) const
{
    return CVector2(x * f, y * f);
}

CVector2 CVector2::operator / ( Float f ) const
{
    Float fInv = 1.0f / f;
    return CVector2(x * fInv, y * fInv);
}


CVector2 operator * ( Float f, const CVector2& v )
{
    return CVector2(f * v.x, f * v.y);
}

}