
//==========================================================================
/** @file
    @brief		xNgZNX
    @author		t`
    @since		2003.07.01
*/
//==========================================================================



//==========================================================================
// INCLUDE
//==========================================================================
#include "LunaBase.h"

#include "LunaVector3.h"
#include "LunaMath.h"
#include "LunaMatrix.h"

namespace lunadxmath{
//==========================================================================
/**
	xNg̒̓擾܂B

    @return		̓
*/
//==========================================================================
Float CVector3::LengthSq( void )
{
	return ((x * x) + (y * y) + (z * z));
}

//==========================================================================
/**
	xNg̒擾܂

    @return		
*/
//==========================================================================
Float CVector3::Length( void )
{
	return (Float)sqrt( LengthSq() );
}

//==========================================================================
/**
	xNgƃxNg̓ς擾܂

	@param pIn		[in] ώZopxNg

    @return		ϒl
*/
//==========================================================================
Float CVector3::DotProduct( CVector3 *pIn )
{
	return ((x * pIn->x) + (y * pIn->y) + (z * pIn->z));
}

//==========================================================================
/**
	KxNg擾܂

	@param pIn		[in] KΏۂ̃xNg
*/
//==========================================================================
void CVector3::Normalize( CVector3 *pIn )
{
	Float div = 1.0f / pIn->Length();
	x = pIn->x * div;
	y = pIn->y * div;
	z = pIn->z * div;
}

//==========================================================================
/**
	xNgƃxNg̊Oς擾܂

	@param pIn1	[in] OώZopxNg
	@param pIn2	[in] OώZopxNg
*/
//==========================================================================
void CVector3::CrossProduct( CVector3 *pIn1, CVector3 *pIn2 )
{
	x = (pIn1->y * pIn2->z) - (pIn1->z * pIn2->y);
	y = (pIn1->z * pIn2->x) - (pIn1->x * pIn2->z);
	z = (pIn1->x * pIn2->y) - (pIn1->y * pIn2->x);
}

//==========================================================================
/**
	Cӂ̃xNgɔ˂Cӂ̔˃xNg擾܂

	@param pIn1	[in] ˑΏۃxNg
	@param pIn2	[in] ˎxNg
*/
//==========================================================================
void CVector3::Reflect( CVector3 *pIn1, CVector3 *pIn2 )
{
	Float dot = pIn1->DotProduct( pIn2 );

	x = pIn1->x - (2 * dot * pIn2->x);
	y = pIn1->y - (2 * dot * pIn2->y);
	z = pIn1->z - (2 * dot * pIn2->z);
}

//==========================================================================
/**
	xNgɉ]sŽʂ擾܂
	
	@param pIn1	[in] ZΏۃxNg
	@param pIn2	[in] Zs
*/
//==========================================================================
void CVector3::TransformNormal( CVector3 *pIn1, CMatrix *pIn2 )
{
	x = (pIn1->x * pIn2->Get(0,0)) + (pIn1->y * pIn2->Get(1,0)) + (pIn1->z * pIn2->Get(2,0));
	y = (pIn1->x * pIn2->Get(0,1)) + (pIn1->y * pIn2->Get(1,1)) + (pIn1->z * pIn2->Get(2,1));
	z = (pIn1->x * pIn2->Get(0,2)) + (pIn1->y * pIn2->Get(1,2)) + (pIn1->z * pIn2->Get(2,2));
}

//==========================================================================
/**
	xNgɍsŽʂ擾܂

	@param pIn1	[in] ZΏۃxNg
	@param pIn2	[in] Zs
*/
//==========================================================================
void CVector3::TransformCoord( CVector3 *pIn1, CMatrix *pIn2 )
{
	x = (pIn1->x * pIn2->Get(0,0)) + (pIn1->y * pIn2->Get(1,0)) + (pIn1->z * pIn2->Get(2,0)) + pIn2->Get(3,0);
	y = (pIn1->x * pIn2->Get(0,1)) + (pIn1->y * pIn2->Get(1,1)) + (pIn1->z * pIn2->Get(2,1)) + pIn2->Get(3,1);
	z = (pIn1->x * pIn2->Get(0,2)) + (pIn1->y * pIn2->Get(1,2)) + (pIn1->z * pIn2->Get(2,2)) + pIn2->Get(3,2);
}

//==========================================================================
/**
	xNgɓϊsŽʂ擾܂

	@param pIn1	[in] ZΏۃxNg
	@param pIn2	[in] Zs
*/
//==========================================================================
void CVector3::TransformProjection( CVector3 *pIn1, CMatrix *pIn2 )
{
	Float _x = (pIn1->x * pIn2->Get(0,0)) + (pIn1->y * pIn2->Get(1,0)) + (pIn1->z * pIn2->Get(2,0)) + pIn2->Get(3,0);
	Float _y = (pIn1->x * pIn2->Get(0,1)) + (pIn1->y * pIn2->Get(1,1)) + (pIn1->z * pIn2->Get(2,1)) + pIn2->Get(3,1);
	Float _z = (pIn1->x * pIn2->Get(0,2)) + (pIn1->y * pIn2->Get(1,2)) + (pIn1->z * pIn2->Get(2,2)) + pIn2->Get(3,2);
	Float _w = (pIn1->x * pIn2->Get(0,3)) + (pIn1->y * pIn2->Get(1,3)) + (pIn1->z * pIn2->Get(2,3)) + pIn2->Get(3,3);

	_w = 1.0f / _w;

	x = _x * _w;
	y = _y * _w;
	z = _z * _w;
}

//==========================================================================
/**
	xNg𐳋K܂

*/
//==========================================================================
void CVector3::Normalize( void )
{
	Float div = 1.0f / Length();
	x *= div;
	y *= div;
	z *= div;
}

//==========================================================================
/**
	xNg̊Oςߌʂ擾

	@param pIn		[in] OϗpxNg
*/
//==========================================================================
void CVector3::CrossProduct( CVector3 *pIn )
{
	CVector3 vTemp = *this;
	x = (vTemp.y * pIn->z) - (vTemp.z * pIn->y);
	y = (vTemp.z * pIn->x) - (vTemp.x * pIn->z);
	z = (vTemp.x * pIn->y) - (vTemp.y * pIn->x);
}

//==========================================================================
/**
	xNg𐳋K

	@param pIn		[in] ˎxNg
*/
//==========================================================================
void CVector3::Reflect( CVector3 *pIn )
{
	CVector3 vTemp = *this;
	Float dot = pIn->DotProduct( &vTemp );

	x = pIn->x - (2 * dot * vTemp.x);
	y = pIn->y - (2 * dot * vTemp.y);
	z = pIn->z - (2 * dot * vTemp.z);
}

//==========================================================================
/**
	xNgɉ]sŽʂ擾܂
	
	@param pIn		[in] Zs
*/
//==========================================================================
void CVector3::TransformNormal( CMatrix *pIn )
{
	CVector3 vTemp = *this;
	x = (vTemp.x * pIn->Get(0,0)) + (vTemp.y * pIn->Get(1,0)) + (vTemp.z * pIn->Get(2,0));
	y = (vTemp.x * pIn->Get(0,1)) + (vTemp.y * pIn->Get(1,1)) + (vTemp.z * pIn->Get(2,1));
	z = (vTemp.x * pIn->Get(0,2)) + (vTemp.y * pIn->Get(1,2)) + (vTemp.z * pIn->Get(2,2));
}

//==========================================================================
/**
	xNgɍsŽʂ擾܂

	@param pIn		[in] Zs
*/
//==========================================================================
void CVector3::TransformCoord( CMatrix *pIn )
{
	CVector3 vTemp = *this;
	x = (vTemp.x * pIn->Get(0,0)) + (vTemp.y * pIn->Get(1,0)) + (vTemp.z * pIn->Get(2,0)) + pIn->Get(3,0);
	y = (vTemp.x * pIn->Get(0,1)) + (vTemp.y * pIn->Get(1,1)) + (vTemp.z * pIn->Get(2,1)) + pIn->Get(3,1);
	z = (vTemp.x * pIn->Get(0,2)) + (vTemp.y * pIn->Get(1,2)) + (vTemp.z * pIn->Get(2,2)) + pIn->Get(3,2);
}

//==========================================================================
/**
	xNgɓϊsŽʂ擾܂

	@param pIn		[in] Zs
*/
//==========================================================================
void CVector3::TransformProjection( CMatrix *pIn )
{
	CVector3 vTemp = *this;
	Float _x = (vTemp.x * pIn->Get(0,0)) + (vTemp.y * pIn->Get(1,0)) + (vTemp.z * pIn->Get(2,0)) + pIn->Get(3,0);
	Float _y = (vTemp.x * pIn->Get(0,1)) + (vTemp.y * pIn->Get(1,1)) + (vTemp.z * pIn->Get(2,1)) + pIn->Get(3,1);
	Float _z = (vTemp.x * pIn->Get(0,2)) + (vTemp.y * pIn->Get(1,2)) + (vTemp.z * pIn->Get(2,2)) + pIn->Get(3,2);
	Float _w = (vTemp.x * pIn->Get(0,3)) + (vTemp.y * pIn->Get(1,3)) + (vTemp.z * pIn->Get(2,3)) + pIn->Get(3,3);

	_w = 1.0f / _w;

	x = _x * _w;
	y = _y * _w;
	z = _z * _w;
}

//==========================================================================
/**
	xNgCӂ̊pxłwɉ]܂

	@param Angle		[in] ]pxi165536j
*/
//==========================================================================
void CVector3::RotationX( Sint32 Angle )
{
	CVector3 vTemp = *this;
	Float s = LunaMath::Sin( Angle );
	Float c = LunaMath::Cos( Angle );

	x = vTemp.x;
	y = (vTemp.y * +c) + (vTemp.z * -s);
	z = (vTemp.y * +s) + (vTemp.z * +c);
}

//==========================================================================
/**
	xNgCӂ̊pxłxɉ]܂

	@param Angle		[in] ]pxi165536j
*/
//==========================================================================
void CVector3::RotationY( Sint32 Angle )
{
	CVector3 vTemp = *this;
	Float s = LunaMath::Sin( Angle );
	Float c = LunaMath::Cos( Angle );

	x = (vTemp.x * +c) + (vTemp.z * +s);
	y = vTemp.y;
	z = (vTemp.x * -s) + (vTemp.z * +c);
}

//==========================================================================
/**
	xNgCӂ̊pxłyɉ]܂

	@param Angle		[in] ]pxi165536j
*/
//==========================================================================
void CVector3::RotationZ( Sint32 Angle )
{
	CVector3 vTemp = *this;
	Float s = LunaMath::Sin( Angle );
	Float c = LunaMath::Cos( Angle );

	x = (vTemp.x * +c) + (vTemp.y * -s);
	y = (vTemp.x * +s) + (vTemp.y * +c);
	z = vTemp.z;
}

//==========================================================================
/**
	xNgCӂ̊pxŔCӂ̎ɉ]܂

	@param Angle		[in] ]pxi165536j
	@param pAxis		[in] ]
*/
//==========================================================================
void CVector3::RotationAxis( Sint32 Angle, CVector3 *pAxis )
{
	CMatrix Mat;
	Mat.RotationAxis( Angle, pAxis );
	TransformNormal( &Mat );
}

//==========================================================================
/**
	xNgCӂ̊pxłRɉ]܂

	@param rotx		[in] w]pxi165536j
	@param roty		[in] x]pxi165536j
	@param rotz		[in] y]pxi165536j
*/
//==========================================================================
void CVector3::Rotation( Sint32 rotx, Sint32 roty, Sint32 rotz )
{
	CMatrix Mat;
	Mat.Rotation( rotx, roty, rotz );
	TransformNormal( &Mat );
}

//==========================================================================
/**
	xNggk܂

	@param sx		[in] wgk
	@param sy		[in] xgk
	@param sz		[in] ygk
*/
//==========================================================================
void CVector3::Scaling( Float sx, Float sy, Float sz )
{
	x *= sx;
	y *= sy;
	z *= sz;
}

//==========================================================================
/**
	xNgړ܂

	@param px		[in] wړ
	@param py		[in] xړ
	@param pz		[in] yړ
*/
//==========================================================================
void CVector3::Translation( Float px, Float py, Float pz )
{
	x += px;
	y += py;
	z += pz;
}

//==========================================================================
/**
	xNgZʂ擾

	@param pIn1	[in] ZxNg
	@param pIn2	[in] ZpxNg
*/
//==========================================================================
void CVector3::Add( CVector3 *pIn1, CVector3 *pIn2 )
{
	x = pIn1->x + pIn2->x;
	y = pIn1->y + pIn2->y;
	z = pIn1->z + pIn2->z;
}

//==========================================================================
/**
	xNgZʂ擾

	@param pIn1	[in] ZxNg
	@param pIn2	[in] ZpxNg
*/
//==========================================================================
void CVector3::Sub( CVector3 *pIn1, CVector3 *pIn2 )
{
	x = pIn1->x - pIn2->x;
	y = pIn1->y - pIn2->y;
	z = pIn1->z - pIn2->z;
}


//==========================================================================
/**
	xNg̊evf̒lݒ

	@param fPx		[in] wl
	@param fPy		[in] xl
	@param fPz		[in] yl
*/
//==========================================================================
void CVector3::Set( Float fPx, Float fPy, Float fPz )
{
	x = fPx;
	y = fPy;
	z = fPz;
}


// assignment operators
CVector3 &CVector3::operator += ( const CVector3& v )
{
    x += v.x;
    y += v.y;
    z += v.z;
    return *this;
}

CVector3 &CVector3::operator -= ( const CVector3& v )
{
    x -= v.x;
    y -= v.y;
    z -= v.z;
    return *this;
}

CVector3 &CVector3::operator *= ( Float f )
{
    x *= f;
    y *= f;
    z *= f;
    return *this;
}

CVector3 &CVector3::operator /= ( Float f )
{
    Float fInv = 1.0f / f;
    x *= fInv;
    y *= fInv;
    z *= fInv;
    return *this;
}


// unary operators
CVector3 CVector3::operator + () const
{
    return *this;
}

CVector3 CVector3::operator - () const
{
    return CVector3(-x, -y, -z);
}


// binary operators
CVector3 CVector3::operator + ( const CVector3& v ) const
{
    return CVector3(x + v.x, y + v.y, z + v.z);
}

CVector3 CVector3::operator - ( const CVector3& v ) const
{
    return CVector3(x - v.x, y - v.y, z - v.z);
}

CVector3 CVector3::operator * ( Float f ) const
{
    return CVector3(x * f, y * f, z * f);
}

CVector3 CVector3::operator / ( Float f ) const
{
    Float fInv = 1.0f / f;
    return CVector3(x * fInv, y * fInv, z * fInv);
}

}